﻿using System.Collections.Generic;
using UnivateProperties_API.Containers.Users;
using UnivateProperties_API.Model.Users;

namespace UnivateProperties_API.Repository.Users
{
    public interface IRegisterRepository
    {
        User Authenticate(string username, string password);
        IEnumerable<User> GetAllUsers();
        IEnumerable<Agency> GetAllAgencies();
        IEnumerable<Individual> GetAllIndividuals();
        User GetById(int id);
        Agency GetByAgencyId(int id);
        Individual GetByIndividualId(int id);
        User Create(User user, string password, bool save);
        Agency CreateAgency(AgencyDto agency);
        void CreatePerson(UserDto individual, PersonType personType, bool save, Agency agency);
        void Update(User user, string password = null);
        void UpdateAgency(Agency agency, string agencyname = null);
        void UpdatePerson(Person person, PersonType personType);
        void Delete(int id);
        void DeleteAgency(int id);
        void DeleteIndividual(int id);
    }
}
