﻿using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Options;
using Microsoft.IdentityModel.Tokens;
using System;
using System.Collections.Generic;
using System.IdentityModel.Tokens.Jwt;
using System.Linq;
using System.Security.Claims;
using System.Text;
using UnivateProperties_API.Context;
using UnivateProperties_API.Model.Users;

namespace UnivateProperties_API.Repository.Users
{
    public class UserRepository : IRepository<User>
    {
        private readonly DataContext _dbContext;

        public UserRepository(DataContext dbContext)
        {
            _dbContext = dbContext;
        }

        public List<User> Get(Func<User, bool> where)
        {
            return _dbContext.Users.Where(where).ToList();
        }

        public List<User> GetAll()
        {
            return _dbContext.Users.ToList();
        }

        public User GetDetailed(Func<User, bool> first)
        {
            var item = _dbContext.Users.FirstOrDefault(first);
            UserRepository account = new UserRepository(_dbContext);
            item = GetDetailedObject(item, account);
            return item;
        }

        private User GetDetailedObject(User item, UserRepository repo)
        {
            item = repo.GetDetailed(x => x.Id == item.Id);
            return item;
        }

        public void Insert(User item)
        {
            _dbContext.Add(item);
            Save();
        }

        public void Insert(IEnumerable<User> item)
        {
            _dbContext.Add(item);
            Save();
        }

        public void Remove(User item)
        {
            var i = _dbContext.Users.Find(item);
            _dbContext.Users.Remove(i);
            Save();
        }

        public void Remove(IEnumerable<User> items)
        {
            foreach (var item in items)
            {
                User i = _dbContext.Users.Find(item);
                _dbContext.Users.Remove(i);
            }
            Save();
        }

        public void RemoveAtId(int item)
        {
            var i = _dbContext.Users.Find(item);
            _dbContext.Users.Remove(i);
            Save();
        }

        public void Update(User item)
        {
            _dbContext.Entry(item).State = EntityState.Modified;
            Save();
        }

        public void Save()
        {
            _dbContext.SaveChanges();
        }

        public List<User> GetDetailedAll()
        {
            throw new NotImplementedException();
        }
    }
}
